#!/bin/sh

# File: ossim-cmake-config.sh

#!/bin/sh 

#export OSSIM_DEV_HOME=$(pwd) -- OSSIM_DEV_HOME must already be defined

# Out-of-source build required for Eclipse project (must be sibling of OSSIM_DEV_HOME)
OSSIM_BUILD_DIR=${OSSIM_DEV_HOME}/../build
if [ ! -e $OSSIM_BUILD_DIR ]; then
  mkdir $OSSIM_BUILD_DIR
fi

# Set this to point to the top-level dir containing external libs not installed on your system
# or comment out and define it in your shell environment
OSSIM_DEPENDENCIES=${OSSIM_DEV_HOME}/../3rdParty

# Permits eclipse generated project to create a sources subproject
cp -f ${OSSIM_DEV_HOME}/ossim_package_support/cmake/CMakeLists.txt ${OSSIM_DEV_HOME}

cd $OSSIM_BUILD_DIR
rm CMakeCache.txt

# CMAKE command. Note argument -j8 for 8-core processor. Modify this for your
# architecture or remove for single-thread.
cmake -G "Eclipse CDT4 - Unix Makefiles" \
-DCMAKE_BUILD_TYPE="Debug" \
-DCMAKE_ECLIPSE_MAKE_ARGUMENTS=-j8 \
-DCMAKE_ECLIPSE_GENERATE_SOURCE_PROJECT=TRUE \
-DCMAKE_VERBOSE_MAKEFILE=ON \
-DBUILD_CSMAPI=OFF \
-DBUILD_LIBRARY_DIR=lib \
-DBUILD_OMS=ONs \
-DBUILD_OSSIM=ON \
-DBUILD_OSSIM_PLUGIN=OFF  \
-DBUILD_OSSIMCONTRIB_PLUGIN=OFF \
-DBUILD_OSSIMCSM_PLUGIN=OFF \
-DBUILD_OSSIMGDAL_PLUGIN=ON \
-DBUILD_OSSIMGEOPDF_PLUGIN=OFF \
-DBUILD_OSSIMHDF4_PLUGIN=OFF \
-DBUILD_OSSIMHDF5_PLUGIN=ON \
-DBUILD_OSSIMKAKADU_PLUGIN=ON \
-DBUILD_OSSIMKMLSUPEROVERLAY_PLUGIN=OFF \
-DBUILD_OSSIMLAS_PLUGIN=OFF \
-DBUILD_OSSIMLIBLAS_PLUGIN=OFF \
-DBUILD_OSSIMLIBRAW_PLUGIN=OFF \
-DBUILD_OSSIMMRSID_PLUGIN=ON \
-DBUILD_OSSIMNDF_PLUGIN=OFF \
-DBUILD_OSSIMPNG_PLUGIN=ON \
-DBUILD_OSSIMREGISTRATION_PLUGIN=OFF \
-DBUILD_OSSIMQT4=ON \
-DBUILD_OSSIMGUI=ON \
-DBUILD_OSSIM_MPI_SUPPORT=OFF \
-DBUILD_OSSIMPLANET=ON \
-DBUILD_OSSIMPLANETQT=ON \
-DBUILD_OSSIMPREDATOR=OFF \
-DBUILD_OSSIM_TEST_APPS=ON \
-DBUILD_RUNTIME_DIR=bin \
-DBUILD_SHARED_LIBS=ON \
-DBUILD_WMS=ON \
-DMRSID_DIR=${OSSIM_DEPENDENCIES}/MrSID_DSDK-9.1.0.4045-linux.x86-64.gcc44 \
-DKAKADU_ROOT_SRC=${OSSIM_DEPENDENCIES}/kakadu-v7_5-01123C \
-DKAKADU_LIBRARY=${OSSIM_DEPENDENCIES}/kakadu-v7_5-01123C/lib/Linux-x86-64-gcc/libkdu.a \
-DKAKADU_AUX_LIBRARY=${OSSIM_DEPENDENCIES}/kakadu-v7_5-01123C/lib/Linux-x86-64-gcc/libkdu_aux.a \
-DCMAKE_INCLUDE_PATH=${OSSIM_DEV_HOME}/ossim/include \
-DCMAKE_INSTALL_PREFIX=${OSSIM_BUILD_DIR} \
-DCMAKE_LIBRARY_PATH=${OSSIM_BUILD_DIR}/lib \
-DCMAKE_MODULE_PATH=${OSSIM_DEV_HOME}/ossim_package_support/cmake/CMakeModules \
-DOSSIM_COMPILE_WITH_FULL_WARNING=ON \
-DOSSIM_DEV_HOME=${OSSIM_DEV_HOME} \
${OSSIM_DEV_HOME}


